/*****************************/
/* kChat v1.8		     */
/* krzak@linux.net.pl        */ 
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.awt.*;

public class kChatProtocol {
    private static kChatParse parseCommand = new kChatParse();
    
    public static void parse(String buf) {
    if (buf.startsWith("*MSG")) 
{
	String who = parseCommand.getParam(buf,2);
	String where = parseCommand.getParam(buf,3);
	String text = parseCommand.getParam(buf,4);
	String color = parseCommand.getParam(buf,5);
        String s = "";
	s = "<"+who+"> "+text;
	if (where.equals("CHAN")) 
{
	    kChatApplet.chanWnd.appendText(s,color);
        }
	// priv, lub do moderatora
	if (where.equals(kChatApplet.login)) 
{
	    if (kChatApplet.moderate) { // to pisze ludek do moderatora
		kChatApplet.chanWndModer.appendText(s,color);
	    } else {
    		if  ((kChatApplet.alreadyExistNick(who) == false)) {
			MsgFloatingWindow fw = new MsgFloatingWindow(kChatApplet.compileText(kChatApplet.TXT[12],who),who);
			fw.setVisible(true);
			fw.text.append("*<"+ who +">* " + text + "\n");
			} else {
			MsgFloatingWindow fw = kChatApplet.getMsgWindowFromList(who);
			fw.text.append("*<"+ who +">* " + text + "\n");
			}
	    }
	}
    }
    
    if (buf.startsWith("*LIST")) 
{
	if (kChatApplet.nList == null) kChatApplet.nList = new List();
	
	int start = 5;	int end = 5;
	while (buf.indexOf("|",start+1) != -1) {
	    start = end+1;
	    end   = buf.indexOf("|",start+1);
	    if ((start<end) && (!buf.substring(start,end).equals(kChatApplet.login))) kChatApplet.nList.addItem(buf.substring(start,end));
	    }
    }

    if (buf.startsWith("*JOIN")) 
{
	String n = parseCommand.getParam(buf,2);
	kChatApplet.nList.addItem(n);
	kChatApplet.chanWnd.appendText(kChatApplet.compileText(kChatApplet.TXT[2],n),"gray"); // "przyszedl"
    }

    if (buf.startsWith("*QUIT")) 
{
	String n = parseCommand.getParam(buf,2);
	for (int i=0;i<kChatApplet.nList.getItemCount();i++) {   
		if ((kChatApplet.nList != null) && (kChatApplet.nList.getItem(i).equals(n))) 
		    kChatApplet.nList.delItem(i); 
	    }
	kChatApplet.chanWnd.appendText(kChatApplet.compileText(kChatApplet.TXT[5],n),"black"); // "wyszedl"
    }

    if (buf.startsWith("*MODERATED")) 
{
	if (buf.substring(11,13).equals("NO")) {
	    kChatApplet.moderate=false;
	    kChatApplet.moderatorNick = "";
	    kChatApplet.chanWnd.appendText(kChatApplet.TXT[4] ,"gray"); // "kanal nie jest moderowany"
	    } else {
	    kChatApplet.moderate=true;
	    kChatApplet.moderatorNick = parseCommand.getParam(buf,3);	    
	    kChatApplet.chanWnd.appendText(kChatApplet.compileText(kChatApplet.TXT[3],kChatApplet.moderatorNick),"gray"); // "kanal moderowany przez "
	    } 
    }

    if (buf.startsWith("*YOUAREMODERATOR")) 
{
	    kChatApplet.moderate=true;
	    kChatApplet.chanWnd.appendText(kChatApplet.compileText(kChatApplet.TXT[14],kChatApplet.chan),"red"); // "jestes moderatorem"
	    kChatApplet.moderWinOpen();
	    kChatApplet.chanWndModer.moderatorMode=true;
	    kChatApplet.bPrivate.setLabel(kChatApplet.TXT[16]);
	    kChatApplet.bPrivate.setActionCommand("KICK");
	    kChatApplet.bModerator.setLabel(kChatApplet.TXT[17]);
	    kChatApplet.bModerator.setActionCommand("TOPIC");
    }
    if (buf.startsWith("*LOGIN")) 
{
	    String s = parseCommand.getParam(buf,2);
	    if (s.equals("OK")) {
		// get login from serwer !!!
		kChatApplet.login=parseCommand.getParam
(buf,3);
		kChatApplet.chanWnd.appendText(kChatApplet.TXT[0],"black");
		kChatApplet.net.send("*MODERATED");
		}
	    if (s.equals("NICK BUSY")) {
		kChatApplet.chanWnd.appendText(kChatApplet.TXT[11],"black"); // "login zajety"
		}

	}
    if (buf.startsWith("*KICK")) 
{
	kChatApplet.chanWnd.appendText(kChatApplet.TXT[15],"black");
	kChatApplet.net.send("*CLOSE\r\n");
    }

    if (buf.startsWith("*PING")) 
{
	kChatApplet.net.send("*PONG\r\n");
    }

    if (buf.startsWith("*LANG")) 
{
	for (int i=0;i<kChatApplet.TXT.length;i++) {
	    kChatApplet.TXT[i] = parseCommand.getParam(buf,i+2);
	    }
	kChatApplet.bPrivate.setLabel(kChatApplet.TXT[6]);
	kChatApplet.bModerator.setLabel(kChatApplet.TXT[7]);
	kChatApplet.bLogout.setLabel(kChatApplet.TXT[8]);
	kChatApplet.bClose.setLabel(kChatApplet.TXT[9]);
    }

    if (buf.startsWith("*TOPIC|GET|")) 
{
	kChatApplet.topicLabel.setText(kChatApplet.chan + " - " + parseCommand.getParam(buf,3));
    }



  }
}