/*****************************/
/* kChat v1.8		     */
/* krzak@linux.net.pl        */ 
/* Marcin Krzyzanowski       */
/* http://krzak.linux.net.pl */
/* License: GPL              */
/*****************************/
/* Copyright (C) 2001  Marcin Krzyzanowski <krzak@linux.net.pl>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
import java.util.*;
import java.io.*;

public class kChatSystem {

    public static String logfile = new String("./chanlog.log");	
    public static String log = new String("no");
    public static String rnicksFilename = "off";
    public static String passwdfile = "";
    public static Hashtable moderpassHT = new Hashtable();
    public static Hashtable moderatedHT  = new Hashtable();
    public static Hashtable topicHT = new Hashtable();
    public static Vector clientList = new Vector();
    public static String lastError = "";
    public static Hashtable moderatorNickHT = new Hashtable();
    public static Hashtable guestNickHT = new Hashtable();
    public static String topicDef = "kChat 1.8 by Marcin Krzyzanowski <krzak@linux.net.pl>";
    public static String TXT[] = new String[18];
    
/*******************************************************************************************/
/* return parameters from line like ex. *one|two|three|, if 'nr' is to big, then return "" */
/*******************************************************************************************/
    public static String getParam(String ln, int nr) {
	if ( (ln==null) || (ln.equals("")) || (!ln.endsWith("|")) ) return("");
	int start = 0; 
	int end  = ln.indexOf("|",0);
	if (end == -1) {
		end = ln.length(); 
	        return(ln.substring(start,end)); 
		}
	nr = nr - 1; /* to count params from 1 not from 0 */
	for (int i=0;i<nr;i++) {
	    start = ln.indexOf("|",end);
	    if (start == (ln.length()-1)) return("");
	    end   = ln.indexOf("|",start+1);
	    }

	if (nr == 0) 
	     return(ln.substring(start,end)); 
	    else 
	     return(ln.substring(start+1,end)); 
	}
	
/*******************************************************************************************/
/* answer for action send to server 							   */
/*******************************************************************************************/
    public static String getAnswerFor(String ln, kChatServerThread th)
    {
    if ((ln == null) || (ln.equals(null)) || (ln.equals(""))) return("UNKNOWN COMMAND");
    /* *CLOSE */
    if (ln.equals("*CLOSE")) {
	quitFromSystem(th.login);
	return("BYE");
	}
	
    /* *WHOAMI */
    if (ln.equals("*WHOAMI")) return(th.clientS.getInetAddress().getHostAddress());

    /* *MODERATED */
    if (ln.equals("*MODERATED")) {
	Boolean bval = (Boolean)moderatedHT.get(th.channelName);
	if (bval.booleanValue()) 
	    return("*MODERATED|YES|"+(String)moderatorNickHT.get(th.channelName)+"|"); 
	    else 
	    return("*MODERATED|NO|");
	}

    /* *LOGIN|SYSTEM|loginname|password|channel| */
    if (ln.startsWith("*LOGIN")) {
	String who = getParam(ln,3);
	String password = getParam(ln,4);
	String chantmp = getParam(ln,5);
	if ((getParam(ln,2).equals("SYSTEM")) &&    // *LOGIN|SYSTEM|
	    (!who.equals("")) &&	            // loginname not empty
	    (loginToSystem(who,password,chantmp,th))) {     // login to system 
	       return("*LOGIN|OK|"+th.login+"|");
	    } else {
	       return("*LOGIN|NICK BUSY|");
	    }     
	}
	
    /* *MSG|who|where|text|color| */	     
    if (ln.startsWith("*MSG"))
 {
        if (th.login.equals("")) return("*ERROR|LOGIN FIRST|");
	if (getParam(ln,4).equals("")) return("*ERROR|UNKNOWN|");
	sendMsgTo(th.login,getParam(ln,3),getParam(ln,4),getParam(ln,5),th.channelName);
        return("");
        }

    /* *CHECK */
    if (ln.startsWith("*CHECK")) {
	String chantmp = getParam(ln,2);
	String out = "*LIST|";
	boolean empty = true;
	if (clientList.size()<=0) return("*LIST|NULL|");
	for (int i=0; i<clientList.size(); i++) {
	    kChatClass tmpE = (kChatClass)clientList.elementAt(i);
	    if (tmpE.channelName.equals(chantmp)) { 
			out = out + tmpE.login + "|";
			empty = false;
			}
	    }
	if (empty) return("*LIST|NULL|");
	return(out);
    }

    /* *MODERATOR|pass|guest| */
    if (ln.startsWith("*MODERATOR")) {
	if (getParam(ln,2).equals("") || getParam(ln,3).equals("")) return("");
	String typedPass  = getParam(ln,2);
	
	    moderpassHT.clear();
	    try {
	    FileReader frpass = new FileReader(passwdfile);
	    BufferedReader frbpass = new BufferedReader(frpass);
	    String linepass = new String();
	    while (linepass!=null) {
		linepass = frbpass.readLine();
		if ((linepass!=null)&&(!linepass.startsWith("#"))&&(!linepass.equals(""))) {
		    String txttmp = linepass.substring(0,linepass.indexOf("=",0));
		    String valtmp = linepass.substring(linepass.indexOf("=",0)+1);
		    kChatSystem.moderpassHT.put(txttmp,valtmp);
		    }
		}
	    } 
	    catch (IOException e) { System.out.println("Check passfile !!!"); }
	
	
	// moderpass is taken everytime from configuration file
	if ((moderpassHT.get(th.channelName)!=null)&&(typedPass.equals((String)moderpassHT.get(th.channelName)))) {
		String typedGuest = getParam(ln,3);
		moderatorNickHT.put(th.channelName,th.login);
		guestNickHT.put(th.channelName,typedGuest);
		moderatedHT.put(th.channelName,new Boolean(true));
		sayToAll("*MODERATED|YES|" + (String)moderatorNickHT.get(th.channelName) + "|",th.channelName);
		return("*YOUAREMODERATOR");
		}
	}
    /* *NOMODERATOR */
    if (ln.startsWith("*NOMODERATOR") && (th.login.equals((String)moderatorNickHT.get(th.channelName)))) {
	sayToAll("*MODERATED|NO|",th.channelName);
	moderatorNickHT.put(th.channelName,new String(""));
	guestNickHT.put(th.channelName,new String(""));
	moderatedHT.put(th.channelName,new Boolean(false));
	return("");
    }
    

    /* *KICK|nickname| */
    Boolean bval = (Boolean)moderatedHT.get(th.channelName);
    if (ln.startsWith("*KICK") && (bval.booleanValue()) && (th.login.equals((String)moderatorNickHT.get(th.channelName))) && (!getParam(ln,2).equals(""))) {
	String tokick = getParam(ln,2);
	for (int i=0;i<clientList.size();i++) {
	    kChatClass tmpE = (kChatClass)clientList.elementAt(i);
	    if (tmpE.login.equals(tokick)) {
		tmpE.watek.pw.println("*KICK\r\n");
		tmpE.watek.pw.flush();
		}
	    }
	quitFromSystem(tokick);
	return("");
	}

    /* *PONG */
    if (ln.startsWith("*PONG")) {
	th.ping = 0;
	return("");
    }

    /* *LANG */
    if (ln.startsWith("*LANG")) {
	String out = "*LANG|";
	for (int i=0;i<TXT.length;i++) out = out + TXT[i] + "|";
	return(out);
    }

    /* *TOPIC|SET/GET|channel|text| */
    if (ln.startsWith("*TOPIC")) {
	String chantmp = getParam(ln,3);
	if (getParam(ln,2).equals("SET") && (th.login.equals((String)moderatorNickHT.get(th.channelName))))  {
	    topicHT.put(chantmp,getParam(ln,4));
	    }
	
	if (!topicHT.containsKey(chantmp)) topicHT.put(chantmp,topicDef);
	sayToAll("*TOPIC|GET|" + topicHT.get(chantmp) + "|",chantmp);
	return("");
    }



    return("UNKNOWN COMMAND");
    }

/*******************************************************************************************/
/* broadcast message  							   */
/*******************************************************************************************/
    public static void sayToAll(String s,String chantmp) {
    kChatClass tmpE = null;
    
    // do ludkow z chantmp tylko
    for (int i = 0; i < clientList.size(); i++) {
	  tmpE = (kChatClass)clientList.elementAt(i);
	  if (tmpE.channelName.equals(chantmp)) {
             tmpE.watek.pw.println(s+"\r\n");
             tmpE.watek.pw.flush();									  
	     }
	 }
    
    // log to file
    if ((s.startsWith("*MSG")) && (log.equals("yes"))) {
	Calendar now = Calendar.getInstance();
	String time = "=" + now.get(Calendar.HOUR) +":"+ now.get(Calendar.MINUTE) +":"+ now.get(Calendar.SECOND) + "= ";
	String st = new String();
	st = time + "<" + getParam(s,2) + "> " + getParam(s,4);
        try {
    	    FileWriter fw = new FileWriter(logfile+"."+chantmp,true);
	    BufferedWriter fwb = new BufferedWriter(fw);
	    fwb.write(st,0,st.length());
	    fwb.newLine();
	    fwb.flush();
	    fwb.close();
	    } catch (IOException e) { e.printStackTrace(); };
	}
    }

/*******************************************************************************************/
/* LOGIN TO SYSTEM  should be fine Mon Oct 22 13:00:50 2000  				   */
/*******************************************************************************************/
    public static boolean loginToSystem(String login, String password, String chantmp, kChatServerThread th)
 {
    if ((login == null) || (login.equals(""))) return(false);
    login = login.replace(' ', '_');
    login = login.replace('|', '_');
    login = login.replace('<', '_');
    login = login.replace('>', '_');
    login = login.replace('~', '_');
    login = login.replace('\r', '_');
    login = login.replace('\n', '_');
    login = login.replace('\t', '_');
    if (login.length()>10) login = login.substring(0,10);
    
    Vector rnicksList = new Vector();
    Vector rnickspassList = new Vector();
    // reserverd list check
    if ((rnicksFilename!=null) && (!rnicksFilename.equals("")) && (!rnicksFilename.equals("off")))
	try {
    	    FileReader fr = new FileReader(rnicksFilename);
    	    BufferedReader frb = new BufferedReader(fr);
	    String line = new String();
	    while (line!=null) {
		line = frb.readLine();
		if ((line!=null)&&(!line.startsWith("#"))&&(!line.equals(""))) {
		    String rnick = line.substring(0,line.indexOf("=",0));
		    String rnickpass   = line.substring(line.indexOf("=",0)+1);
		    rnicksList.addElement(rnick);
		    rnickspassList.addElement(rnickpass);
		}
	    }
	} catch (IOException e) { System.out.println("Check reserved-nicks-list-file option ot its file !!!"); }
    
    
    // check for reserved nick
    for(int j=0;j<rnicksList.size();j++) {
        String rn = (String)rnicksList.elementAt(j);
        String rnpass = (String)rnickspassList.elementAt(j);
        if ((rn.equals(login))&&(!rnpass.equals(password))) return(false);
        }

    for (int i = 0; i < clientList.size(); i++) {
	kChatClass tmpE = (kChatClass)clientList.elementAt(i);
	if (tmpE.login.equals(login))  return(false); 
	}

    kChatClass tmpC = new kChatClass();
    tmpC.login = login;
    tmpC.channelName = chantmp;
    tmpC.watek = th;
    tmpC.perm = 0;
    clientList.addElement(tmpC);
    th.login = login;
    th.channelName = chantmp;
    if (!moderatedHT.containsKey(th.channelName))
	moderatedHT.put(th.channelName, new Boolean(false));
    sayToAll("*JOIN|"+login+"|",chantmp);
    return(true);
    }

/*******************************************************************************************/
/* LOGOUT FROM SYSTEM       							   */
/*******************************************************************************************/
   public static boolean quitFromSystem(String login)
 {
   if (login == null || login.equals("")) { return(false); };
   for (int i = 0; i < clientList.size(); i++) {
	kChatClass tmpE = (kChatClass)clientList.elementAt(i);
	if (tmpE.login.equals(login)) { 
	    sayToAll("*QUIT|"+login+"|",tmpE.channelName);
	    if (login.equals((String)moderatorNickHT.get(tmpE.channelName))) {
		moderatedHT.put(tmpE.channelName,new Boolean(false));
		moderatorNickHT.put(tmpE.channelName,new String(""));
		guestNickHT.put(tmpE.channelName,new String(""));
		sayToAll("*MODERATED|NO|",tmpE.channelName);
		}
	    clientList.removeElementAt(i);
	    // close connection
	    try { tmpE.watek.clientS.close(); } 
catch (IOException e) { e.printStackTrace(); }
	    // stop thread
	    tmpE.watek.stop();
	    }
	}
   return(true);
   }

/*******************************************************************************************/
/* MESSAGE       							   */
/*******************************************************************************************/
    public static boolean sendMsgTo(String from, String to, String text, String color, String chantmp)
 {
    String action = "*MSG";
    boolean cantalk = false;
    int poz = -1;
    kChatClass tmpE = new kChatClass();

    Boolean bval = (Boolean)moderatedHT.get(chantmp);
    if (bval.booleanValue()) { 
	if (to.equals((String)guestNickHT.get(chantmp)) || to.equals((String)moderatorNickHT.get(chantmp))) return(false); // if to moderator or guest (priv) ignore
	if (to.equals("CHAN")) to = (String)moderatorNickHT.get(chantmp); // redirect all to moderator
	if (from.equals((String)guestNickHT.get(chantmp)) || from.equals((String)moderatorNickHT.get(chantmp))) to = "CHAN";  // from moder or guest redir to CHAN
	}

    // check if you want to do something as somone who doesn't exist in system
    for (int i = 0; i < clientList.size(); i++) {
	tmpE = (kChatClass)clientList.elementAt(i);
	if (tmpE.login.equals(from)) cantalk = true; 
	if (tmpE.login.equals(to)) poz = i;
	}

    if (!cantalk) return(false);

    if (!to.equals("CHAN")) {
 // priv
	  if (poz != -1)  {
 // if "to" really exists
    	    tmpE = (kChatClass)clientList.elementAt(poz);
    	    tmpE.watek.pw.println(action +"|"+from+"|"+to+"|"+text+"|" + color + "|\r\n");
    	    tmpE.watek.pw.flush();
    	    }

	} else { // to CHAN
	bval = (Boolean)moderatedHT.get(chantmp);
	if ((bval.booleanValue())&&(text.startsWith("~<"))&&(from.equals((String)moderatorNickHT.get(chantmp)))) {
	    from = text.substring(2,text.indexOf(" ",2)-1);
	    text = text.substring(text.indexOf(" ",2)+1,text.length());
	    }
	sayToAll(action + "|"+from+"|"+to+"|"+text+"|" + color +"|",chantmp);
	}
    return(true);
    }

}
